#########################################
# Mr V Bouncer/FTP Tester v1.0 (Public) #
#########################################
# Simple ftp checker..                  #
# reports stuff to irc                  #
# set topic & msg users                 #
# easy configuration, very customizable #
#########################################
# Installation:                         #
# load this tcl on your eggie config..  #
# rehash/restart/start the bot...       #
# do !bncchk (you must be owner)        #
# and after that.. !bnc                 #
# You need THE FTP-LIB.TCL (included)   #
#########################################
# Features:                             #
# -Informs on channels the change-Status#
#  ..of a bouncer (DOWN<->UP)           #
# -Auto-Updates the channels Topic for  #
#  ..the bouncer Info                   #
#########################################
# Expected stuff for v3.0..             #
# -MRTG Support                         #
# -SQL Support                          #
#########################################
# Author:       vampirito@vampirito.com #
#########################################
# SiteName ?
set siteName "TC"
# BNC File (Where info is stored)
set bnc(file) "/glftpd/ftp-data/misc/bncs.lst"
# MSG on Status Change ?
set bnc(chans_msg) "1"
# Announce Channels ?
set bnc(chans) "#MrV"
# Change topic on Status Change ?
set bnc(topic_chg) "1"
# TopicSet Channels ?
set topiChans "#MrV"
# AutoCheck bncs ? by default every 10 minutes
set bnc(auto_check) "1"
# Bouncers Configuration (ARRAYS)
# bnc(list) "NAME NAME NAME"
# bnc(NAME) "host/ip:port"
set bnc(list) "NL NL-2 SE ES-1 ES-2 FI US-1 US-2"
set bnc(NL) "ftp.student.utwente.nl:21"
set bnc(NL-2) "ftp.wau.nl:21"
set bnc(SE) "ftp.sunet.se:21"
set bnc(ES-1) "ftp.rediris.es:21"
set bnc(ES-2) "ftp.upc.es:21"
set bnc(FI) "ftp.utu.fi:21"
set bnc(US-1) "ftp.unc.edu:21"
set bnc(US-2) "ftp.fsu.edu:21"
# FTP-LIB Configuration
set bnc(user) "anonymous"
set bnc(pass) "terra@terra.es"
set bnc(lib) "/glftpd/eggdrop/scripts/ftp_lib.tcl"
set bnc(string) "!bnc"
bind time "00,10,20,30,40,50 * * * *" bnc:check
proc bnc:info {name} { global bnc
        foreach bouncer $bnc(list) {
                if {[string match -nocase "$name" "$bouncer"]} {
                        set ip [lindex [split $bnc($bouncer) ":"] 0]
                        set port [lindex [split $bnc($bouncer) ":"] end]
                }
        }
        if {![info exist port]} {
                return 0
        } else {
                if {$port == ""} { set port 21 }
                return "$ip $port"
        }
}

proc bnc:msg {dest data} { global siteName
        putserv "PRIVMSG $dest :(\002$siteName\002) $data"
}

proc bnc:line {} { global bnc
        if {![file exist $bnc(file)]} {
                putlog "\[vBnc\] Bouncer file not found.. cant obtain LongLine"
                return 0
        }
        set fline ""
        set of [open $bnc(file) r]
        while {![eof $of]} {
                set line [gets $of]
                if {$line != ""} {
                        append fline "\[[lindex $line 0] - [lindex $line 1]\] "
                }
        }
        close $of
        if {$fline == ""} {
                putlog "\[vBnc\] Info could not be extracted or is empty"
                return 0
        } else {
                return "$fline"
        }
}

proc bnc:topic {} { global bnc siteName
        set fline [bnc:line]
        if {$fline == ""} { return 0 }
        foreach chan $bnc(chans) {
                putserv "TOPIC $chan :(\002$siteName\002) $fline (\002$siteName\002)"
                putlog "\[vBnc\] ..updated topic of $chan correctly.."
        }
}

proc bnc:cinfo {name} { global bnc
        if {![info exist bnc($name)]} {
                putlog "\[vBnc\] ..bouncer does not exist"
                return 0
        }
        set bncInfo [bnc:info $name]
        set bncIp [lindex $bncInfo 0]
        set bncPort [lindex $bncInfo 1]
        set starts [clock clicks -milliseconds]
        catch {FTP::Open $bncIp $bncPort $bnc(user) $bnc(pass)} z
        if {$z == 1} {
                putlog "\[vBnc\] $name bouncer is up"
                set status($name) "UP"
                FTP::Close
        } else {
                putlog "\[vBnc\] $name bouncer is down"
                set status($name) "Down"
        }
        set startf [clock clicks -milliseconds]
        set dlms [string range [expr $startf - $starts] end-2 end]
        set dls [string range [expr $startf - $starts] 0 end-3]
        if {$dls == ""} { set dls 0 }
        set delay($name) "$dls.$dlms"
        return "$status($name) $delay($name)"
}

proc bnc:chkname {name} { global bnc
        if {[string match -nocase "*${name}*" "$bnc(list)"]} {
                return 1
        } else {
                return 0
        }
}

proc bnc:chkchan {chan} { global bnc
        foreach chanb $bnc(chans) {
                if {[string match -nocase "$chan" "$chanb"]} {
                        return 1
                }
        }
}

proc bnc:pinfo {nick uhost hand chan text} { global bnc
        if {[bnc:chkchan $chan] == 0 } { return 0 }
        if {![file exist $bnc(file)]} { return 0 }
        set of [open $bnc(file) r]
        while {![eof $of]} {
                set line [gets $of]
                if {$line != ""} {
                        set name [lindex $line 0]
                        set bncInfo [bnc:info $name]
                        set ip [lindex $bncInfo 0]
                        set port [lindex $bncInfo 1]
                        if {([lindex $line 2] != "") && ([lindex $line 1] != "Down")} {
                                bnc:msg $nick ">>\002[lindex $line 0]\002<< \002$ip\002:$port>> STATUS: \002[lindex $line 1]\002 (Delay: \002[lindex $line 2]\002secs)"
                        } else {
                                bnc:msg $nick ">>\002[lindex $line 0]\002<< \002$ip\002:$port>> STATUS: \002[lindex $line 1]\002"
                        }
                }
        }
        close $of
}

proc bnc:check {} { global bnc siteName
        putlog "\[vBnc\] ..checking bncs.. please be patient.."
        set merged 0
        if {![file exist $bnc(file)]} { set oldStats 0 } else { set oldStats 1 }
        if  {$oldStats == 1} {
                set if [open $bnc(file) r]
                while {![eof $if]} {
                        set line [gets $if]
                        if {$line != ""} {
                                set oname [lindex $line 0]
                                set ostatus($oname) [lindex $line 1]
                                set odelay($oname) [lindex $line 2]
                        }
                }
                close $if
        }
        set of [open $bnc(file) w]
        foreach name $bnc(list) {
                set bncInfo [bnc:info $name]
                set ip [lindex $bncInfo 0]
                set port [lindex $bncInfo 1]
                set bouncer(info) "[bnc:cinfo $name]"
                set bouncer(status) "[lindex $bouncer(info) 0]"
                set bouncer(delay) "[lindex $bouncer(info) 1]"
                if {[info exist ostatus($name)]} {
                        if {$ostatus($name) != $bouncer(status)} {
                                putlog "\[vBnc\] $name bouncer changed status from $ostatus($name) to $bouncer(status)"
                                if {($bnc(chans_msg) == 1) && ($merged == 0)} {
                                        bnc:chans "..updated bouncer status.. type '$bnc(string)' for get the list of avaiables bouncers.."
                                        set merged 1
                                }
                        }
                }
                puts $of "$name $bouncer(status) $bouncer(delay) $ip $port"
        }
        close $of
        if {$bnc(topic_chg) == 1} {
                putlog "\[vBnc\] ..updating topics.."
                bnc:topic
        }
        putlog "\[vBnc\] ..check finished.."
}

proc bnc:chans {data} { global bnc siteName
        foreach chan $bnc(chans) {
                putserv "PRIVMSG $chan :(\002$siteName\002) $data"
        }
}

bind pub -|- $bnc(string) bnc:pinfo
proc bnc:notice {dest data} { global siteName
        putserv "NOTICE $dest :(\002$siteName\002) $data"
}

bind pub n|n $bnc(string)chk bnc:chkp
proc bnc:chkp {nick uhost hand chan text} { global siteName
        bnc:msg $nick "Checking bncs.. be patient.."
        bnc:check
        bnc:msg $nick "Check done.."
}

if {[file exist $bnc(lib)]} {
        source $bnc(lib)
} else {
        die "FTP Lib does not exist.."
}